program selection_sar;

const N = 9;

{ paprasta struktura }
type struktura = record
                   i1 : integer;
                   i2 : integer;
                   r1 : real;
                   r2 : real
                 end;

{ dvikryptis sarasas }
type sarasas2kr = ^irasas2kr;
     irasas2kr = record
                   str   : struktura;
                   ankst : sarasas2kr;
                   kitas : sarasas2kr
                 end;

{ struktura 'studentas' }
type studentas = record
                   vardas : string;
                   pavarde : string;
                   stud_paz_nr : integer;
                   specialybe : string;
                   kursas : integer;
                   grupe : integer;
                   login : string
                 end;

{------------------------------------------------------------}

{ saraso spausdinimas nuo pradzios }
procedure spausdinti_sar2kr_pr (s : sarasas2kr);
begin
  while s <> nil do
  begin
    // write (' ', s^.str.i1, '-', s^.str.i2, '-', s^.str.r1:2:2, '-', s^.str.r2:2:2);
    write (' ', s^.str.i1 {, '-', s^.str.i2});
    s := s^.kitas
  end;
  writeln
end;

{ saraso spausdinimas nuo pabaigos }
procedure spausdinti_sar2kr_pab (s : sarasas2kr);
begin
  while s <> nil do
  begin
    // write (' ', s^.str.i1, '-', s^.str.i2, '-', s^.str.r1:2:2, '-', s^.str.r2:2:2);
    write (' ', s^.str.i1, '-', s^.str.i2);
    s := s^.ankst
  end;
  writeln
end;

{ iterpimas i saraso pradzia }
procedure iterpti_sar2kr_pr (var spr, spb : sarasas2kr; pi1, pi2 : integer; pr1, pr2 : real);
  var p : sarasas2kr;
begin
  new (p);
  p^.str.i1 := pi1;
  p^.str.i2 := pi2;
  p^.str.r1 := pr1;
  p^.str.r2 := pr2;
  p^.ankst := nil;
  p^.kitas := spr;

  if spr = nil then
  begin
    spr := p;
    spb := p
  end
  else begin
         spr^.ankst := p;
         spr := p
       end
end;

{ iterpimas i saraso pabaiga }
procedure iterpti_sar2kr_pab (var spr, spb : sarasas2kr; pi1, pi2 : integer; pr1, pr2 : real);
  var p : sarasas2kr;
begin
  new (p);
  p^.str.i1 := pi1;
  p^.str.i2 := pi2;
  p^.str.r1 := pr1;
  p^.str.r2 := pr2;
  p^.ankst := spb;
  p^.kitas := nil;

  if spb = nil then
  begin
    spr := p;
    spb := p
  end
  else begin
         spb^.kitas := p;
         spb := p
       end
end;

{ ismetimas is saraso pradzios }
procedure ismesti_sar2kr_pr (var spr, spb : sarasas2kr);
  var p : sarasas2kr;
begin
  if spr <> nil then
  begin
    p := spr;
    spr := spr^.kitas;
    dispose (p);
    if spr <> nil then spr^.ankst := nil
                  else spb := nil
  end
end;

{ ismetimas is saraso pabaigos }
procedure ismesti_sar2kr_pab (var spr, spb : sarasas2kr);
  var p : sarasas2kr;
begin
  if spb <> nil then
  begin
    p := spb;
    spb := spb^.ankst;
    dispose (p);
    if spb <> nil then spb^.kitas := nil
                  else spr := nil
  end
end;

{------------------------------------------------------------}

{ saraso inicializacija }
procedure inicializuoti_sar (var spr, spb : sarasas2kr);
begin
  while spr <> nil do ismesti_sar2kr_pab (spr, spb);
end;

{ skaiciaus sarase suradimas }
function rasti_sar2kr (s : sarasas2kr; sk1, sk2 : integer) : boolean;
  var b : boolean;
begin
  b := false;
  while s <> nil do
  begin
    if (s^.str.i1 = sk1) or (s^.str.i2 = sk2) then
    begin
      b := true;
      break
    end;
    s := s^.kitas
  end;
  rasti_sar2kr := b
end;

{ saraso uzpildymas }
procedure uzpildyti_sar2kr (var spr, spb : sarasas2kr);
  var i, val1, val2 : integer;
begin
  inicializuoti_sar (spr, spb);
  randomize;
  for i := 1 to N do
  begin
    repeat
      val1 := 1 + random (99);
      val2 := 1 + random (99);
    until not rasti_sar2kr(spr, val1, val2);
    iterpti_sar2kr_pab (spr, spb, val1, val2, 0, 0)
  end
end;


procedure selection_sar_did (spr, spb : sarasas2kr);
  var pr1, pr2, min, s : sarasas2kr;
                     t : struktura;

begin
  pr1:=spr;
  s:=spr;
  writeln ('Rusiuojam: ');
  while pr1<>nil do
      begin
        spausdinti_sar2kr_pr (s);
        min:=pr1;
        pr2:=pr1^.kitas;

        while pr2<>nil do
            begin
              if pr2^.str.i1 < min^.str.i1 then  min:=pr2;
              pr2:=pr2^.kitas;
            end;

        t:=min^.str;
        min^.str:=pr1^.str;
        pr1^.str:=t;
        pr1:=pr1^.kitas;
      end;//while


  writeln ('Surusiavom. ');
end;










{------------------------------------------------------------}

{ apsirasom sarasa }
var pr, pb : sarasas2kr;

begin
  writeln;
  writeln ('Pradedama programa...');
  pr := nil;
  pb := nil;

  // burbulas didejanciai sarasui
  writeln;
  writeln ('--- Sarasui didejanciai ---');
  uzpildyti_sar2kr (pr, pb);
  write ('Nerusiuotas:');
  spausdinti_sar2kr_pr (pr);
  selection_sar_did (pr, pb);
  write ('Surusiuotas:');
  spausdinti_sar2kr_pr (pr);



  writeln;
  writeln ('Baigta programa.');
  readln;
end.
